/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package georouting.node;

import georouting.Graph;
import georouting.traversalAlgorithms.CFR;
import georouting.traversalAlgorithms.CFRM_GMP;
import georouting.traversalAlgorithms.PostOffice;
import java.util.HashSet;

/**
 *
 * @author Jordan
 */
public class CFRNode extends StaticNode{
    private HashSet<CFR> sendQueue;
    private int lastRcvd_ = 0;
    private CFRNode preference_;
 
    public CFRNode(double x, double y, Graph g){
        super(x, y, g);
        sendQueue = new HashSet<>();
    }
    
    public boolean hasMate(CFR message){
//        System.out.println(message + " - Has Mate:");
        for(CFR mate : sendQueue){
//            System.out.println(mate);
            if(mate.isMate(message)){
//                System.out.println("-Mate found-");
                mate.discard();
                return true;
            }
        }
        return false;
    }
    
    public boolean hasAssassin(){
        return !sendQueue.isEmpty();
    }
    
    public void receive(CFR message){
        sendQueue.add(message);
    }
    
    public void send(CFR message){
        sendQueue.remove(message);
    }
    
    public void deliver(CFR message){
        if(message.id() > lastRcvd_){
            lastRcvd_++;
            PostOffice.instance().deliver(message);
        }
    }
    
    public CFRNode getPreference(){
        return preference_;
    }
    
    public void setPreference(CFRNode prefered){
        preference_ = prefered;
    }
}