/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package georouting.planarization;

import georouting.Edge;
import georouting.Node;
import georouting.PlanarizationAlgorithm;
import georouting.node.ImaginaryNode;
import java.awt.geom.Rectangle2D;
import java.util.Iterator;
import java.util.List;

/**
 *
 * @author Jordan
 */
public class PartialGG extends PlanarizationAlgorithm{
    private Rectangle2D safeArea_;
    
    public PartialGG(Rectangle2D safe){
        safeArea_ = safe;
    }
    
    public List<Edge> planarize(List<Edge> edges)
  { // the return is redundent, the array is going to be modified during the algorithm
    // which will affect the call to neighborhood, thus this approch will actually work
    // (recall that neighborhood is resolved based on edge connections)
      
    Iterator<Edge> edge_it = edges.iterator();
    while(edge_it.hasNext()){
        Edge edge = edge_it.next();
       
        if(!(safeArea_.contains(edge.n1().point()) && safeArea_.contains(edge.n2().point()))){
            float midX = (edge.n1().x() - edge.n2().x()) / 2.f + edge.n2().x();
            float midY = (edge.n1().y() - edge.n2().y()) / 2.f + edge.n2().y();
            float rad  = edge.n1().distance(edge.n2()) / 2.f;

            ImaginaryNode midPt = new ImaginaryNode(midX, midY);
       
            for(Node neighbor : edge.n1().neighborhood()){
                if(neighbor != edge.n2() && neighbor.distance(midPt) <= rad){
                    edge_it.remove();
                    break;
                }
            }
        }
    }      
    return edges;
  }
}
