/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package georouting.simulation;

import static java.lang.Math.pow;
import java.util.ArrayList;
import java.util.TreeMap;

/**
 *
 * @author Jordan
 */
public class DataSet {
    private final TreeMap<Double, ArrayList<Double>> data_ = new TreeMap<>();
    
    public void add(Double x, Double y){
        if(!data_.containsKey(x))
            data_.put(x, new ArrayList<Double>());
        data_.get(x).add(y);
    }
    
    public void clear(){
        data_.clear();
    }
    
    double average(Double x){
        double total = 0;
        
        if(data_.containsKey(x)){
            for(Double e : data_.get(x))
            total += e;
        
            total /= (data_.get(x).size() > 0? data_.get(x).size() : 1);
        }
                
        return total;
    }
    
    double stDev(Double x){
        double xbar = average(x);
        double total = 0;
        
        if(data_.containsKey(x)){
            for(Double e : data_.get(x))
            total += pow(e - xbar, 2);
        
            total /= (data_.get(x).size() > 0? data_.get(x).size() : 1);
        }
                
        return Math.sqrt(total);
    }
}
