/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package georouting.simulation;

import georouting.ConnectivityContract;
import georouting.Node;
import georouting.PlanarizationAlgorithm;
import georouting.TraversalAlgorithm;
import georouting.Visualizer;
import georouting.connectivity.StaticUnitDiskConnectivity;
import georouting.graph.CFRGraph;
import georouting.graph.StaticGraph;
import georouting.node.ImaginaryNode;
import georouting.planarization.GabrialGraph;
import georouting.traversalAlgorithms.*;
import java.util.ArrayList;
import java.util.Random;

/**
 *
 * @author Jordan
 */
public class DebugTest {

    private static final double unitDistance_ = 50.0;
    private static final ConnectivityContract cc_ = new StaticUnitDiskConnectivity(unitDistance_);
    private static final PlanarizationAlgorithm algo_ = new GabrialGraph();

    public static void main(String[] args) {
        Random rand_ = new Random();
        TraversalAlgorithm message;
        StaticGraph graph;
        Node source;
        ArrayList<Node> dests = new ArrayList<>();
        int hops = 0;

        for (int comp = 0; comp < 1; comp++) {
            graph = new CFRGraph(5, 10 * unitDistance_, 10 * unitDistance_, cc_);
            graph.planarize(algo_);

            source = graph.nodes().get(0);

            dests.clear();
            for (int i = 1; i < (int)(graph.nodes().size() * 0.25); i++) {
                dests.add(graph.nodes().get(i));
            }

            message = new GMP_dev(graph, source, dests, unitDistance_, algo_);
//            message = new GFG_GMP(graph, source, dests.get(0), algo_);
            GMP_dev.setCastingTargets(dests);
            
            Visualizer visual = new Visualizer(graph);
            visual.begin();
            
            while(!message.done()){
//                System.out.println(message);
                message.advance();
            }
            
            hops += message.hops();
                        
            if(comp % 10 == 0)
                System.out.println((comp + 1) + " / 1000");
            
            //visual.dispose();
        }
        System.out.println("average hops: " + hops / 1000);
    }
}
