/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package georouting.simulation;

import georouting.ConnectivityContract;
import georouting.graph.CFRGraph;
import georouting.connectivity.StaticUnitDiskConnectivity;
import georouting.planarization.GabrialGraph;
import georouting.traversalAlgorithms.*;
import georouting.Node;
import georouting.PlanarizationAlgorithm;
import georouting.TraversalAlgorithm;
import georouting.Visualizer;
import georouting.connectivity.CDSDisk;
import georouting.graph.StaticGraph;
import georouting.node.CFRNode;
import georouting.planarization.PartialGG;
import java.awt.geom.Rectangle2D;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Random;
import java.util.TreeMap;
import java.util.logging.Level;
import java.util.logging.Logger;

public class StaticSim {
    
    // Parameters
    private static final double unitDistance_ = 50.0;
    private static final ConnectivityContract cc_ = new StaticUnitDiskConnectivity(unitDistance_);
    
    static Rectangle2D rec = new Rectangle2D.Double(50, 50, 200, 200);

    private static final PlanarizationAlgorithm algo_ = new PartialGG(rec);
    
    public static void main(String[] args){
        //((CDSDisk)cc_).setRegion(rec);
        StaticGraph graph = new CFRGraph(6, 10 * unitDistance_, 10 * unitDistance_, cc_);
        graph.planarize(algo_);
        
        Visualizer window = new Visualizer(graph);
        window.begin();
    }
}
