/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package georouting.traversalAlgorithms;

import georouting.Graph;
import georouting.Node;
import georouting.PlanarizationAlgorithm;
import georouting.node.CFRNode;
import java.util.ArrayList;
import java.util.Iterator;

/**
 *
 * @author Jordan
 */
public class DFlood extends CFRG{
    public DFlood(Graph g, Node s, Node f, PlanarizationAlgorithm pa){
        super(g, s, f, pa);
    }
    
    public DFlood(Graph g, Node s, Node f, Node c, Node t, int id, ArrayList<Node> path, PlanarizationAlgorithm pa){
        super(g, s, f, c, t, id, path, pa);  
    }
    
    @Override
    public void initiate(){
        visit(_current);
        
        if(_current.neighborhood().size() > 0){           
            split(null);
            ((CFRNode)_current).receive(this);

            PostOffice.instance().merge();
        }        
    }
    
    @Override
    public void split(Node origin){
        Iterator<Node> target_i = _current.neighborhood().iterator();
        
        Node target;
        while(target_i.hasNext()){
            target = target_i.next();
            if(target != origin){
                target_ = target;
                break;
            }
        }
        
        while(target_i.hasNext()){
            target = target_i.next();
            if(target != origin){
                DFlood spawn = new DFlood(_container, _source, _destination, _current, target, id_, path_, _pAlg);
                ((CFRNode)_current).receive(spawn);
                PostOffice.instance().add(spawn);
            }
        }
    }

    @Override
    public void advance(){
        advanceAlgorithm();
    }
    
    @Override
    protected void advanceAlgorithm(){
        if(!done()){
            if(!((CFRNode)target_).hasMate(this)){                
                moveTo(target_);
                visit(_current);
                
                if(_current.neighborhood().size() > 1)
                    split(_previous);
                else discard();
            }
            else{
                PostOffice.instance().addPacket();
                broadcasts_++;
                discard();
            }
        }
    }
    
    @Override
    public boolean isMate(CFR message){
        return message.target_ == _current &&
               message.current() == target_;
    }
    
    static public int castSize(){
        return castTargets_.size();
    }
}
