/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package georouting.traversalAlgorithms;

import georouting.Graph;
import georouting.Node;
import georouting.TraversalAlgorithm;
import georouting.node.CFRNode;

/**
 *
 * @author Jordan
 */
public class Forwarder extends TraversalAlgorithm{
    public Forwarder(Graph g, Node s, Node d){
        super(g, s, d);
    }
   
    @Override
    public void advance(){
        if(_current == _destination){
            PostOffice.instance().deliver(this);
            PostOffice.instance().remove(this);
        }
        else{
            CFRNode target = ((CFRNode)_current).getPreference();
            if(target != null && _current.neighborhood().contains(target)){
                moveTo(target);
                if(_current == _destination){
                    PostOffice.instance().deliver(this);
                    PostOffice.instance().remove(this);
                }
            }
            else{
                // We failed - insert repair code here; for now, we just abort
                PostOffice.instance().remove(this);
            }
        }        
    }
    
    private void moveTo(Node n) {
        _hops ++;
        _current = n;
        PostOffice.instance().addPacket();
    }
    
    @Override
    public String toString(){
        return "S: " + Integer.toString(_source.id()) + ", D: " + Integer.toString(_destination.id())
                + ", C: " + Integer.toString(_current.id());
    }
}
