/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package georouting.traversalAlgorithms;

import georouting.Graph;
import georouting.Node;
import georouting.PlanarizationAlgorithm;
import georouting.node.ImaginaryNode;
import java.util.ArrayList;

/**
 *
 * @author Jordan
 */
public class GFG extends FACE{
    protected boolean greedy_;
    protected float   goal_;
    
    public GFG(Graph g, Node s, Node d, PlanarizationAlgorithm pa){
        super(g, s, d, pa);
        greedy_ = true;
        goal_ = s.distance(d);
    }
    
    @Override
    public void advanceAlgorithm(){
        if(greedy_){
            Node min = _current;
            for(Node neighbor : _current.neighborhood())
                if(neighbor.distance(_destination) < min.distance(_destination))
                    min = neighbor;
            
            if(min != _current)
                moveTo(min);
            else{
                //Switch to face mode
                _previous = null;
                _X = new ImaginaryNode(_current);
                greedy_ = false;
                goal_ = _current.distance(_destination);
                
                super.advanceAlgorithm();
            }
        }
        else{
            if(_current.distance(_destination) < goal_){
                greedy_ = true;
                advanceAlgorithm();
            }
            else
                super.advanceAlgorithm();
        }
    }
    
    @Override
    public String toString(){
        return "S: " + Integer.toString(_source.id()) + ", D: " + Integer.toString(_destination.id())
                + ", P: " + Integer.toString(_previous == null ? -1 : _previous.id()) + ", "
                + ", C: " + Integer.toString(_current.id()) + ", Mode: " + (greedy_ ? "Greedy" : "Face")
                + (!greedy_ ? (_dir == Direction.CLOCKWISE ? "C" : "CC") : "");
    }
    
    @Override
    public String name(){
        return "GFG";
    }
}
